﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace ActiveWaiting
{
    class Program
    {
        static void Main(string[] args)
        {
            bool canIEnter = false;
            Task[] tasks = new Task[8];

            //This tas is very lazy and set canIEnter = true after 10s
            Task t1 = Task.Factory.StartNew(() =>
            {
                for (int i = 0; i < 10; i++)
                    {
                        Console.WriteLine("I'm lazy ...");
                        Thread.Sleep(1000);
                    }
                canIEnter = true;
            });
            //we create 8 tasks that make procesor busy
            for (int i = 0; i < 8; i++)
            {
                tasks[i] = Task.Factory.StartNew(() =>
                {
                    while (!canIEnter) ; //Active waiting = Hot CPU :) try add Thread.Sleep(1)
                    Console.WriteLine("I got in");
                });
            }
                                    
            t1.Wait();
            Task.WaitAll(tasks);
            Console.ReadLine();
        }
    }
}
